var browser;
;
if (window["chrome"])
    browser = window["chrome"];
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    var HObject = /** @class */ (function () {
        function HObject() {
            this.className = "HObject";
        }
        HObject.is = function (a, className) {
            return a.className == className;
        };
        return HObject;
    }());
    hinstDomElementCounter.HObject = HObject;
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
///<reference path="HObject.ts"/>
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    var ReportInfo = /** @class */ (function (_super) {
        __extends(ReportInfo, _super);
        function ReportInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.Total = 0;
            _this.Mapped = {};
            _this.className = ReportInfo.ClassName;
            return _this;
        }
        ReportInfo.prototype.add = function (tagName) {
            this.Total++;
            tagName = tagName.toLowerCase();
            if (this.Mapped[tagName])
                this.Mapped[tagName]++;
            else
                this.Mapped[tagName] = 1;
        };
        ReportInfo.prototype.equals = function (a) {
            if (this == a)
                return true;
            if (this.Total != a.Total)
                return false;
            for (var x in this.Mapped) {
                if (this.Mapped[x] != a.Mapped[x])
                    return false;
            }
            return true;
        };
        ReportInfo.ClassName = "ReportInfo";
        return ReportInfo;
    }(hinstDomElementCounter.HObject));
    hinstDomElementCounter.ReportInfo = ReportInfo;
    var ReportInfoRow = /** @class */ (function () {
        function ReportInfoRow() {
        }
        ReportInfoRow.getRemainingSum = function (a, n) {
            var sum = 0;
            for (var i = n; i < a.length; ++i)
                sum += a[i].count;
            return sum;
        };
        return ReportInfoRow;
    }());
    hinstDomElementCounter.ReportInfoRow = ReportInfoRow;
    function CreateReportInfoRows(info) {
        var result = [];
        for (var key in info.Mapped) {
            var row = new ReportInfoRow();
            row.tag = key;
            row.count = info.Mapped[key];
            result.push(row);
        }
        return result;
    }
    hinstDomElementCounter.CreateReportInfoRows = CreateReportInfoRows;
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    function formatNumber4(x) {
        if (x < 10 * 1000)
            return "" + x;
        else if (x < 1000 * 1000) {
            return "" + Math.floor(x / 1000) + "k";
        }
        else if (x < 1000 * 1000 * 1000)
            return "" + Math.floor(x / 1000 / 1000) + "M";
        else
            return "MANY";
    }
    hinstDomElementCounter.formatNumber4 = formatNumber4;
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    var RequestReport = /** @class */ (function () {
        function RequestReport() {
            this.className = RequestReport.ClassName;
        }
        RequestReport.ClassName = "RequestReport";
        return RequestReport;
    }());
    hinstDomElementCounter.RequestReport = RequestReport;
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
///<reference path="../../common/browser.ts"/>
///<reference path="../../common/ReportInfo.ts"/>
///<reference path="../../common/formatNumber4.ts"/>
///<reference path="../../common/RequestReport.ts"/>
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    console.log("Dom Element Counter: background starting...");
    var Reports = {};
    var activeTabId = 0;
    browser.browserAction.setBadgeBackgroundColor({ color: "#0000FF88" });
    browser.runtime.onMessage.addListener(function (message, sender) {
        if (hinstDomElementCounter.HObject.is(message, hinstDomElementCounter.ReportInfo.ClassName) && !message.tabId) {
            var report = message;
            report.tabId = sender.tab.id;
            browser.browserAction.setBadgeText({
                text: "" + hinstDomElementCounter.formatNumber4(report.Total),
                tabId: report.tabId,
            });
            Reports[report.tabId] = report;
            if (activeTabId == report.tabId)
                browser.runtime.sendMessage(report);
        }
        if (hinstDomElementCounter.HObject.is(message, hinstDomElementCounter.RequestReport.ClassName)) {
            if (Reports[activeTabId])
                browser.runtime.sendMessage(Reports[activeTabId]);
        }
    });
    browser.tabs.onActivated.addListener(function (activeInfo) {
        activeTabId = activeInfo.tabId;
        browser.runtime.sendMessage(Reports[activeInfo.tabId]);
    });
    browser.tabs.onRemoved.addListener(function (tabId) {
        console.log("Deleting " + tabId);
        delete Reports[tabId];
    });
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
//# sourceMappingURL=background.js.map