var browser;
;
if (window["chrome"])
    browser = window["chrome"];
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    function truncStringDots(a, n) {
        if (a.length > n)
            a = a.substring(0, n) + "...";
        return a;
    }
    hinstDomElementCounter.truncStringDots = truncStringDots;
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    var HObject = /** @class */ (function () {
        function HObject() {
            this.className = "HObject";
        }
        HObject.is = function (a, className) {
            return a.className == className;
        };
        return HObject;
    }());
    hinstDomElementCounter.HObject = HObject;
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
///<reference path="HObject.ts"/>
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    var ReportInfo = /** @class */ (function (_super) {
        __extends(ReportInfo, _super);
        function ReportInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.Total = 0;
            _this.Mapped = {};
            _this.className = ReportInfo.ClassName;
            return _this;
        }
        ReportInfo.prototype.add = function (tagName) {
            this.Total++;
            tagName = tagName.toLowerCase();
            if (this.Mapped[tagName])
                this.Mapped[tagName]++;
            else
                this.Mapped[tagName] = 1;
        };
        ReportInfo.prototype.equals = function (a) {
            if (this == a)
                return true;
            if (this.Total != a.Total)
                return false;
            for (var x in this.Mapped) {
                if (this.Mapped[x] != a.Mapped[x])
                    return false;
            }
            return true;
        };
        ReportInfo.ClassName = "ReportInfo";
        return ReportInfo;
    }(hinstDomElementCounter.HObject));
    hinstDomElementCounter.ReportInfo = ReportInfo;
    var ReportInfoRow = /** @class */ (function () {
        function ReportInfoRow() {
        }
        ReportInfoRow.getRemainingSum = function (a, n) {
            var sum = 0;
            for (var i = n; i < a.length; ++i)
                sum += a[i].count;
            return sum;
        };
        return ReportInfoRow;
    }());
    hinstDomElementCounter.ReportInfoRow = ReportInfoRow;
    function CreateReportInfoRows(info) {
        var result = [];
        for (var key in info.Mapped) {
            var row = new ReportInfoRow();
            row.tag = key;
            row.count = info.Mapped[key];
            result.push(row);
        }
        return result;
    }
    hinstDomElementCounter.CreateReportInfoRows = CreateReportInfoRows;
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
var React;
(function (React) {
    var UID = 0;
    var idPrefix = "react_";
    function addContents(element, contents) {
        for (var _i = 0, contents_1 = contents; _i < contents_1.length; _i++) {
            var content = contents_1[_i];
            if (typeof content == "string" || typeof content == "number")
                element.innerText += content;
            if (typeof content == "object")
                element.appendChild(content);
        }
    }
    function setAttributes(element, attributes) {
        for (var attr in attributes) {
            var value = attributes[attr];
            if (typeof value == "string") {
                element.setAttribute(attr, value);
            }
        }
    }
    function createElement(tag, attributes) {
        var contents = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            contents[_i - 2] = arguments[_i];
        }
        var element = document.createElement(tag);
        ++UID;
        element.id = idPrefix + UID;
        setAttributes(element, attributes);
        addContents(element, contents);
        return element;
    }
    React.createElement = createElement;
})(React || (React = {}));
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    var RequestReport = /** @class */ (function () {
        function RequestReport() {
            this.className = RequestReport.ClassName;
        }
        RequestReport.ClassName = "RequestReport";
        return RequestReport;
    }());
    hinstDomElementCounter.RequestReport = RequestReport;
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
///<reference path="../../common/browser.ts"/>
///<reference path="../../common/string.ts"/>
///<reference path="../../common/ReportInfo.ts"/>
///<reference path="../../common/React.ts"/>
///<reference path="../../common/RequestReport.ts"/>
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    var rowCountLimit = 10;
    var mainDiv = document.getElementById("main");
    mainDiv.innerText = "...";
    function appendRow(table, tagName, count, bold) {
        if (bold === void 0) { bold = false; }
        var row = React.createElement("tr", null);
        table.appendChild(row);
        var tagCell = React.createElement("td", null, tagName);
        row.appendChild(tagCell);
        var countCell = React.createElement("td", null, count);
        if (bold)
            countCell.setAttribute("style", "font-weight: bold");
        row.appendChild(countCell);
    }
    browser.runtime.onMessage.addListener(function (msg) {
        if (hinstDomElementCounter.HObject.is(msg, hinstDomElementCounter.ReportInfo.ClassName) && msg.tabId) {
            var report = msg;
            console.log(report);
            mainDiv.innerHTML = "";
            var table = React.createElement("table", null);
            mainDiv.appendChild(table);
            appendRow(table, "TOTAL", report.Total, true);
            var rows = hinstDomElementCounter.CreateReportInfoRows(report).sort(function (a, b) { return b.count - a.count; });
            var mainRows = rows.slice(0, rowCountLimit);
            for (var _i = 0, mainRows_1 = mainRows; _i < mainRows_1.length; _i++) {
                var row = mainRows_1[_i];
                var tagTitle = hinstDomElementCounter.truncStringDots(row.tag, 12);
                appendRow(table, tagTitle, row.count);
            }
            if (mainRows.length < rows.length)
                appendRow(table, "OTHER", hinstDomElementCounter.ReportInfoRow.getRemainingSum(rows, mainRows.length));
        }
    });
    browser.runtime.sendMessage(new hinstDomElementCounter.RequestReport());
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
//# sourceMappingURL=popup.js.map